/*
 * 20110720-14-3106.c
 *
 *	方程式 「x^5 - x = 8」の根を二分法を用いて求める
 */

#include <stdio.h>
#include <math.h>
#include "s_print.h"
#include "s_input.h"

/*
 *	二分法による、方程式「x^5 - x = 8」の根の計算
 */

#define	EPSILON	(0.0001)	/* 最小誤差小数点 4 位にする */

double x5_x_sub ( double min, double max, double mid ) {

	   if ( max - min < EPSILON ) {

				/*
				 * 十分に精度が得られたので、その結果を値とする
				 */


	/*
	**	 この部分を完成させなさい
	*/


	   } else if ( mid*mid*mid*mid*mid - mid - 8 < 0.0 ) {

				/*
				 * 答は mid と max の間にある
				 */


	/*
	**	 この部分を完成させなさい
	*/


	   } else {

				/*
				 * 答は min と mid の間にある
				 */

			return x5_x_sub ( min, mid, (min+mid)/2.0 );
	   }

}

double x5_x ( void ) {

		/*
		 *	8 > 1 ならば x^5 - x = 8 の解は 0.0 と 8 の間にある
		 */

	   return x5_x_sub ( 0.0, 8, 8/2.0 );

}

/*
 *
 */

int main ( void ) {
	double q = x5_x();

	s_print_string ( "x^5 - x = 8 の方程式の解は約 " );
	s_print_double ( q );
	s_print_string ( " です\n" );

	s_print_string ( "確かに " );
	s_print_double ( q );
	s_print_string ( "^5 - " );
	s_print_double ( q );
	s_print_string ( " = " );
	s_print_double ( q * q * q * q * q - q - 8 );
	s_print_string ( " とほぼ零です\n" );

  return 0;
}

/*
 *
 */

